"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
function createReducer(reducerName, initialState, handlers) {
    if (arguments.length <= 2) {
        handlers = __assign({}, initialState);
        initialState = reducerName;
    }
    handlers[reducerName + '_BINDING_UPDATE'] = function (data, action) {
        return data.setIn(action.path, action.value);
    };
    return function (state, action) {
        if (state === void 0) { state = initialState; }
        return handlers[action.type] ?
            handlers[action.type](state, action) :
            state;
    };
}
exports.__esModule = true;
exports["default"] = createReducer;
//# sourceMappingURL=createReducer.js.map